]> git.saurik.com Git - apt.git/blame - cmdline/apt-key.in
VersionHash: Do not skip too long dependency lines
[apt.git] / cmdline / apt-key.in
CommitLineData
b3d44315
MV
1#!/bin/sh
2
3set -e
dac074b0 4unset GREP_OPTIONS
fecfbf2e 5export IFS="$(printf "\n\b")"
b3d44315 6
5b2c6ddc 7MASTER_KEYRING='&keyring-master-filename;'
bc8f83a5 8eval "$(apt-config shell MASTER_KEYRING APT::Key::MasterKeyring)"
5b2c6ddc 9ARCHIVE_KEYRING='&keyring-filename;'
bc8f83a5 10eval "$(apt-config shell ARCHIVE_KEYRING APT::Key::ArchiveKeyring)"
5b2c6ddc 11REMOVED_KEYS='&keyring-removed-filename;'
bc8f83a5 12eval "$(apt-config shell REMOVED_KEYS APT::Key::RemovedKeys)"
5b2c6ddc 13ARCHIVE_KEYRING_URI='&keyring-uri;'
bc8f83a5 14eval "$(apt-config shell ARCHIVE_KEYRING_URI APT::Key::ArchiveKeyringURI)"
4a242c5b 15
3d0def05
DK
16aptkey_echo() { echo "$@"; }
17
00c6e1a3
MV
18requires_root() {
19 if [ "$(id -u)" -ne 0 ]; then
84b286f6 20 echo >&2 "ERROR: This command can only be used by root."
00c6e1a3
MV
21 exit 1
22 fi
23}
24
e23ee4c2 25command_available() {
ee385a36 26 if [ -x "$1" ]; then return 0; fi
e23ee4c2
DK
27 # command -v "$1" >/dev/null 2>&1 # not required by policy, see #747320
28 # which "$1" >/dev/null 2>&1 # is in debianutils (essential) but not on non-debian systems
29 local OLDIFS="$IFS"
30 IFS=:
31 for p in $PATH; do
32 if [ -x "${p}/${1}" ]; then
33 IFS="$OLDIFS"
34 return 0
35 fi
36 done
37 IFS="$OLDIFS"
38 return 1
39}
40
bc8f83a5
DK
41escape_shell() {
42 echo "$@" | sed -e "s#'#'\"'\"'#g"
43}
44
ba72845c 45get_fingerprints_of_keyring() {
fecfbf2e 46 aptkey_execute "$GPG_SH" --keyring "$1" --with-colons --fingerprint | while read publine; do
ba72845c
DK
47 # search for a public key
48 if [ "${publine%%:*}" != 'pub' ]; then continue; fi
49 # search for the associated fingerprint (should be the very next line)
50 while read fprline; do
51 if [ "${fprline%%:*}" = 'sub' ]; then break; # should never happen
52 elif [ "${fprline%%:*}" != 'fpr' ]; then continue; fi
53 echo "$fprline" | cut -d':' -f 10
54 done
25f27319
DK
55 # order in the keyring shouldn't be important
56 done | sort
ba72845c
DK
57}
58
7fbe42c0 59add_keys_with_verify_against_master_keyring() {
bc8f83a5
DK
60 ADD_KEYRING="$1"
61 MASTER="$2"
f87338d2 62
8c56b1e0 63 if [ ! -f "$ADD_KEYRING" ]; then
84b286f6 64 echo >&2 "ERROR: '$ADD_KEYRING' not found"
8c56b1e0 65 return
84b286f6 66 fi
8c56b1e0 67 if [ ! -f "$MASTER" ]; then
84b286f6 68 echo >&2 "ERROR: '$MASTER' not found"
8c56b1e0
MV
69 return
70 fi
71
72 # when adding new keys, make sure that the archive-master-keyring
73 # is honored. so:
3a341a1d
MV
74 # all keys that are exported must have a valid signature
75 # from a key in the $distro-master-keyring
ba72845c 76 add_keys="$(get_fingerprints_of_keyring "$ADD_KEYRING")"
bc8f83a5
DK
77 all_add_keys="$(aptkey_execute "$GPG_SH" --keyring "$ADD_KEYRING" --with-colons --list-keys | grep ^[ps]ub | cut -d: -f5)"
78 master_keys="$(aptkey_execute "$GPG_SH" --keyring "$MASTER" --with-colons --list-keys | grep ^pub | cut -d: -f5)"
f87338d2
DK
79
80 # ensure there are no colisions LP: #857472
81 for all_add_key in $all_add_keys; do
82 for master_key in $master_keys; do
83 if [ "$all_add_key" = "$master_key" ]; then
84 echo >&2 "Keyid collision for '$all_add_key' detected, operation aborted"
85 return 1
86 fi
87 done
88 done
0dae96a2 89
8c56b1e0 90 for add_key in $add_keys; do
f87338d2 91 # export the add keyring one-by-one
0dae96a2 92 local TMP_KEYRING="${GPGHOMEDIR}/tmp-keyring.gpg"
fecfbf2e
DK
93 aptkey_execute "$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --output "$TMP_KEYRING" --export "$add_key"
94 if ! aptkey_execute "$GPG_SH" --batch --yes --keyring "$TMP_KEYRING" --import "$MASTER" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
c1642be5 95 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
0dae96a2
DK
96 false
97 fi
98 # check if signed with the master key and only add in this case
99 ADDED=0
8c56b1e0 100 for master_key in $master_keys; do
fecfbf2e
DK
101 if aptkey_execute "$GPG_SH" --keyring "$TMP_KEYRING" --check-sigs --with-colons "$add_key" \
102 | grep '^sig:!:' | cut -d: -f5 | grep -q "$master_key"; then
103 aptkey_execute "$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --export "$add_key" \
104 | aptkey_execute "$GPG" --batch --yes --import
c9bb37c7 105 ADDED=1
8c56b1e0 106 fi
7fbe42c0 107 done
c9bb37c7
MV
108 if [ $ADDED = 0 ]; then
109 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
110 fi
0dae96a2 111 rm -f "${TMP_KEYRING}"
8c56b1e0 112 done
7fbe42c0 113}
4a242c5b 114
848ecfa4
MV
115# update the current archive signing keyring from a network URI
116# the archive-keyring keys needs to be signed with the master key
117# (otherwise it does not make sense from a security POV)
118net_update() {
bc8f83a5
DK
119 local APT_DIR='/'
120 eval $(apt-config shell APT_DIR Dir)
121
f87338d2 122 # Disabled for now as code is insecure (LP: #1013639 (and 857472, 1013128))
5acf154d
MV
123 APT_KEY_NET_UPDATE_ENABLED=""
124 eval $(apt-config shell APT_KEY_NET_UPDATE_ENABLED APT::Key::Net-Update-Enabled)
125 if [ -z "$APT_KEY_NET_UPDATE_ENABLED" ]; then
126 exit 1
127 fi
f87338d2 128
848ecfa4 129 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
00c6e1a3 130 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
46e39c8e
MV
131 exit 1
132 fi
133 # in theory we would need to depend on wget for this, but this feature
134 # isn't useable in debian anyway as we have no keyring uri nor a master key
e23ee4c2 135 if ! command_available 'wget'; then
00c6e1a3 136 echo >&2 "ERROR: an installed wget is required for a network-based update"
46e39c8e 137 exit 1
848ecfa4 138 fi
fecfbf2e
DK
139 if [ ! -d "${APT_DIR}/var/lib/apt/keyrings" ]; then
140 mkdir -p "${APT_DIR}/var/lib/apt/keyrings"
848ecfa4 141 fi
fecfbf2e 142 keyring="${APT_DIR}/var/lib/apt/keyrings/$(basename "$ARCHIVE_KEYRING_URI")"
93886541
MV
143 old_mtime=0
144 if [ -e $keyring ]; then
bc8f83a5 145 old_mtime=$(stat -c %Y "$keyring")
93886541 146 fi
fecfbf2e
DK
147 (cd "${APT_DIR}/var/lib/apt/keyrings"; wget --timeout=90 -q -N "$ARCHIVE_KEYRING_URI")
148 if [ ! -e "$keyring" ]; then
93886541
MV
149 return
150 fi
fecfbf2e 151 new_mtime=$(stat -c %Y "$keyring")
93886541 152 if [ $new_mtime -ne $old_mtime ]; then
3d0def05 153 aptkey_echo "Checking for new archive signing keys now"
fecfbf2e 154 add_keys_with_verify_against_master_keyring "$keyring" "$MASTER_KEYRING"
93886541 155 fi
848ecfa4
MV
156}
157
4a242c5b 158update() {
f4dcab05
DK
159 if [ -z "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then
160 echo >&2 "Warning: 'apt-key update' is deprecated and should not be used anymore!"
161 if [ -z "$ARCHIVE_KEYRING" ]; then
162 echo >&2 "Note: In your distribution this command is a no-op and can therefore be removed safely."
163 exit 0
164 fi
165 fi
fecfbf2e 166 if [ ! -f "$ARCHIVE_KEYRING" ]; then
4a242c5b 167 echo >&2 "ERROR: Can't find the archive-keyring"
5b2c6ddc 168 echo >&2 "Is the &keyring-package; package installed?"
4a242c5b
MV
169 exit 1
170 fi
171
3a341a1d
MV
172 # add new keys from the package;
173
174 # we do not use add_keys_with_verify_against_master_keyring here,
1171258a 175 # because "update" is run on regular package updates. A
3a341a1d
MV
176 # attacker might as well replace the master-archive-keyring file
177 # in the package and add his own keys. so this check wouldn't
178 # add any security. we *need* this check on net-update though
f14cde2c 179 import_keyring_into_keyring "$ARCHIVE_KEYRING" '' && cat "${GPGHOMEDIR}/gpgoutput.log"
4a242c5b 180
364af2ef
MV
181 if [ -r "$REMOVED_KEYS" ]; then
182 # remove no-longer supported/used keys
ba72845c 183 get_fingerprints_of_keyring "$REMOVED_KEYS" | while read key; do
5beb682d 184 foreach_keyring_do 'remove_key_from_keyring' "$key"
364af2ef
MV
185 done
186 else
84b286f6 187 echo >&2 "Warning: removed keys keyring $REMOVED_KEYS missing or not readable"
364af2ef 188 fi
4a242c5b
MV
189}
190
04937adc 191remove_key_from_keyring() {
4b30c1dc
DK
192 local KEYRINGFILE="$1"
193 shift
5beb682d
DK
194 # non-existent keyrings have by definition no keys
195 if [ ! -e "$KEYRINGFILE" ]; then
196 return
197 fi
198
0b94a7bc 199 for KEY in "$@"; do
25f27319
DK
200 local FINGERPRINTS="${GPGHOMEDIR}/keyringfile.keylst"
201 get_fingerprints_of_keyring "$KEYRINGFILE" > "$FINGERPRINTS"
f7bd44ba 202
e289907f
DK
203 # strip leading 0x, if present:
204 KEY="$(echo "${KEY#0x}" | tr -d ' ')"
f7bd44ba 205
25f27319
DK
206 # check if the key is in this keyring
207 if ! grep -iq "^[0-9A-F]*${KEY}$" "$FINGERPRINTS"; then
4b30c1dc
DK
208 continue
209 fi
210 if [ ! -w "$KEYRINGFILE" ]; then
211 echo >&2 "Key ${KEY} is in keyring ${KEYRINGFILE}, but can't be removed as it is read only."
212 continue
213 fi
214 # check if it is the only key in the keyring and if so remove the keyring altogether
25f27319 215 if [ '1' = "$(uniq "$FINGERPRINTS" | wc -l)" ]; then
4b30c1dc
DK
216 mv -f "$KEYRINGFILE" "${KEYRINGFILE}~" # behave like gpg
217 return
218 fi
219 # we can't just modify pointed to files as these might be in /usr or something
220 local REALTARGET
221 if [ -L "$KEYRINGFILE" ]; then
222 REALTARGET="$(readlink -f "$KEYRINGFILE")"
223 mv -f "$KEYRINGFILE" "${KEYRINGFILE}.dpkg-tmp"
224 cp -a "$REALTARGET" "$KEYRINGFILE"
225 fi
226 # delete the key from the keyring
fecfbf2e 227 aptkey_execute "$GPG_SH" --keyring "$KEYRINGFILE" --batch --delete-keys --yes "$KEY"
4b30c1dc
DK
228 if [ -n "$REALTARGET" ]; then
229 # the real backup is the old link, not the copy we made
230 mv -f "${KEYRINGFILE}.dpkg-tmp" "${KEYRINGFILE}~"
231 fi
232 done
04937adc
DK
233}
234
105503b4
DK
235accessible_file_exists() {
236 if ! test -s "$1"; then
237 return 1
238 fi
239 if test -r "$1"; then
240 return 0
241 fi
242 warn "The key(s) in the keyring $1 are ignored as the file is not readable by user '$USER' executing apt-key."
243 return 1
244}
245
4b30c1dc
DK
246foreach_keyring_do() {
247 local ACTION="$1"
248 shift
b0d40854 249 # if a --keyring was given, just work on this one
4b30c1dc
DK
250 if [ -n "$FORCED_KEYRING" ]; then
251 $ACTION "$FORCED_KEYRING" "$@"
252 else
253 # otherwise all known keyrings are up for inspection
105503b4 254 if accessible_file_exists "$TRUSTEDFILE"; then
5beb682d
DK
255 $ACTION "$TRUSTEDFILE" "$@"
256 fi
4b30c1dc 257 local TRUSTEDPARTS="/etc/apt/trusted.gpg.d"
bc8f83a5 258 eval "$(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)"
4b30c1dc 259 if [ -d "$TRUSTEDPARTS" ]; then
0cfec3ab
DK
260 TRUSTEDPARTS="$(readlink -f "$TRUSTEDPARTS")"
261 local TRUSTEDPARTSLIST="$(cd /; find "$TRUSTEDPARTS" -mindepth 1 -maxdepth 1 -name '*.gpg')"
262 for trusted in $(echo "$TRUSTEDPARTSLIST" | sort); do
105503b4 263 if accessible_file_exists "$trusted"; then
5beb682d
DK
264 $ACTION "$trusted" "$@"
265 fi
4b30c1dc 266 done
04937adc 267 fi
4b30c1dc 268 fi
04937adc
DK
269}
270
0b94a7bc 271run_cmd_on_keyring() {
5beb682d
DK
272 local KEYRINGFILE="$1"
273 shift
0b94a7bc 274 # fingerprint and co will fail if key isn't in this keyring
fecfbf2e 275 aptkey_execute "$GPG_SH" --keyring "$KEYRINGFILE" --batch "$@" 2>/dev/null || true
5beb682d
DK
276}
277
f14cde2c
DK
278import_keyring_into_keyring() {
279 local FROM="${1:-${GPGHOMEDIR}/pubring.gpg}"
280 local TO="${2:-${GPGHOMEDIR}/pubring.gpg}"
281 shift 2
282 rm -f "${GPGHOMEDIR}/gpgoutput.log"
283 # the idea is simple: We take keys from one keyring and copy it to another
3a8776a3 284 # we do this with so many checks in between to ensure that WE control the
f14cde2c
DK
285 # creation, so we know that the (potentially) created $TO keyring is a
286 # simple keyring rather than a keybox as gpg2 would create it which in turn
287 # can't be read by gpgv.
288 # BEWARE: This is designed more in the way to work with the current
289 # callers, than to have a well defined it would be easy to add new callers to.
290 if [ ! -s "$TO" ]; then
291 if [ -s "$FROM" ]; then
292 if [ -z "$2" ]; then
fecfbf2e 293 if ! aptkey_execute "$GPG_SH" --keyring "$FROM" --export ${1:+"$1"} > "$TO" 2> "${GPGHOMEDIR}/gpgoutput.log"; then
f14cde2c
DK
294 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
295 false
296 else
297 chmod 0644 -- "$TO"
298 fi
299 else
300 create_new_keyring "$TO"
301 fi
302 else
303 create_new_keyring "$TO"
304 fi
305 elif [ -s "$FROM" ]; then
306 local EXPORTLIMIT="$1"
307 if [ -n "$1$2" ]; then shift; fi
fecfbf2e
DK
308 if ! aptkey_execute "$GPG_SH" --keyring "$FROM" --export ${EXPORTLIMIT:+"$EXPORTLIMIT"} \
309 | aptkey_execute "$GPG_SH" --keyring "$TO" --batch --import "$@" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
f14cde2c
DK
310 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
311 false
312 fi
0dae96a2
DK
313 fi
314}
315
105503b4
DK
316catfile() {
317 cat "$1" >> "$2"
318}
319
25f27319
DK
320merge_all_trusted_keyrings_into_pubring() {
321 # does the same as:
322 # foreach_keyring_do 'import_keys_from_keyring' "${GPGHOMEDIR}/pubring.gpg"
323 # but without using gpg, just cat and find
dd7758b9 324 local PUBRING="$(readlink -f "${GPGHOMEDIR}")/pubring.gpg"
105503b4
DK
325 rm -f "$PUBRING"
326 touch "$PUBRING"
327 foreach_keyring_do 'catfile' "$PUBRING"
25f27319
DK
328}
329
f14cde2c
DK
330import_keys_from_keyring() {
331 import_keyring_into_keyring "$1" "$2"
332}
333
0dae96a2 334merge_keys_into_keyrings() {
f14cde2c 335 import_keyring_into_keyring "$2" "$1" '' --import-options 'merge-only'
0dae96a2
DK
336}
337
338merge_back_changes() {
339 if [ -n "$FORCED_KEYRING" ]; then
340 # if the keyring was forced merge is already done
341 return
342 fi
343 if [ -s "${GPGHOMEDIR}/pubring.gpg" ]; then
344 # merge all updated keys
345 foreach_keyring_do 'merge_keys_into_keyrings' "${GPGHOMEDIR}/pubring.gpg"
346 fi
0b94a7bc 347 # look for keys which were added or removed
0dae96a2
DK
348 get_fingerprints_of_keyring "${GPGHOMEDIR}/pubring.orig.gpg" > "${GPGHOMEDIR}/pubring.orig.keylst"
349 get_fingerprints_of_keyring "${GPGHOMEDIR}/pubring.gpg" > "${GPGHOMEDIR}/pubring.keylst"
25f27319
DK
350 comm -3 "${GPGHOMEDIR}/pubring.keylst" "${GPGHOMEDIR}/pubring.orig.keylst" > "${GPGHOMEDIR}/pubring.diff"
351 # key isn't part of new keyring, so remove
352 cut -f 2 "${GPGHOMEDIR}/pubring.diff" | while read key; do
353 if [ -z "$key" ]; then continue; fi
354 foreach_keyring_do 'remove_key_from_keyring' "$key"
355 done
356 # key is only part of new keyring, so we need to import it
357 cut -f 1 "${GPGHOMEDIR}/pubring.diff" | while read key; do
358 if [ -z "$key" ]; then continue; fi
359 import_keyring_into_keyring '' "$TRUSTEDFILE" "$key"
0dae96a2 360 done
5beb682d
DK
361}
362
363setup_merged_keyring() {
b0d40854 364 if [ -n "$FORCED_KEYID" ]; then
25f27319 365 merge_all_trusted_keyrings_into_pubring
b0d40854
DK
366 FORCED_KEYRING="${GPGHOMEDIR}/forcedkeyid.gpg"
367 TRUSTEDFILE="${FORCED_KEYRING}"
fecfbf2e 368 echo "#!/bin/sh
bc8f83a5 369exec sh '($(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh"
fecfbf2e 370 GPG="${GPGHOMEDIR}/gpg.1.sh"
b0d40854 371 # ignore error as this "just" means we haven't found the forced keyid and the keyring will be empty
f14cde2c 372 import_keyring_into_keyring '' "$TRUSTEDFILE" "$FORCED_KEYID" || true
b0d40854 373 elif [ -z "$FORCED_KEYRING" ]; then
25f27319 374 merge_all_trusted_keyrings_into_pubring
0dae96a2
DK
375 if [ -r "${GPGHOMEDIR}/pubring.gpg" ]; then
376 cp -a "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg"
377 else
378 touch "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg"
0740a310 379 fi
fecfbf2e 380 echo "#!/bin/sh
bc8f83a5 381exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${GPGHOMEDIR}/pubring.gpg")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh"
fecfbf2e 382 GPG="${GPGHOMEDIR}/gpg.1.sh"
0dae96a2 383 else
0dae96a2 384 create_new_keyring "$TRUSTEDFILE"
fecfbf2e 385 echo "#!/bin/sh
bc8f83a5 386exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh"
fecfbf2e 387 GPG="${GPGHOMEDIR}/gpg.1.sh"
5beb682d
DK
388 fi
389}
390
0dae96a2
DK
391create_new_keyring() {
392 # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead.
393 if ! [ -e "$TRUSTEDFILE" ]; then
394 if [ -w "$(dirname "$TRUSTEDFILE")" ]; then
395 touch -- "$TRUSTEDFILE"
396 chmod 0644 -- "$TRUSTEDFILE"
397 fi
398 fi
399}
5beb682d 400
fecfbf2e
DK
401aptkey_execute() { sh "$@"; }
402
b3d44315 403usage() {
46e39c8e 404 echo "Usage: apt-key [--keyring file] [command] [arguments]"
b3d44315
MV
405 echo
406 echo "Manage apt's list of trusted keys"
407 echo
408 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
409 echo " apt-key del <keyid> - remove the key <keyid>"
bf6d5b42
OS
410 echo " apt-key export <keyid> - output the key <keyid>"
411 echo " apt-key exportall - output all trusted keys"
4a242c5b 412 echo " apt-key update - update keys using the keyring package"
848ecfa4 413 echo " apt-key net-update - update keys using the network"
b3d44315 414 echo " apt-key list - list keys"
a8cabc8f
LB
415 echo " apt-key finger - list fingerprints"
416 echo " apt-key adv - pass advanced options to gpg (download key)"
b3d44315 417 echo
46e39c8e 418 echo "If no specific keyring file is given the command applies to all keyring files."
b3d44315
MV
419}
420
3dc55197
DK
421while [ -n "$1" ]; do
422 case "$1" in
423 --keyring)
424 shift
425 TRUSTEDFILE="$1"
04937adc 426 FORCED_KEYRING="$1"
3dc55197 427 ;;
b0d40854
DK
428 --keyid)
429 shift
430 FORCED_KEYID="$1"
431 ;;
bd7fb5aa
DK
432 --secret-keyring)
433 shift
434 FORCED_SECRET_KEYRING="$1"
33a22672
DK
435 ;;
436 --readonly)
437 merge_back_changes() { true; }
fecfbf2e 438 create_new_keyring() { if [ ! -r "$FORCED_KEYRING" ]; then TRUSTEDFILE='/dev/null'; FORCED_KEYRING="$TRUSTEDFILE"; fi; }
bd7fb5aa 439 ;;
3dc55197
DK
440 --fakeroot)
441 requires_root() { true; }
3dc55197 442 ;;
3d0def05
DK
443 --quiet)
444 aptkey_echo() { true; }
3d0def05 445 ;;
c1642be5
DK
446 --debug1)
447 # some cmds like finger redirect stderr to /dev/null …
fecfbf2e 448 aptkey_execute() { echo 'EXEC:' "$@"; sh "$@"; }
c1642be5
DK
449 ;;
450 --debug2)
451 # … other more complicated ones pipe gpg into gpg.
fecfbf2e 452 aptkey_execute() { echo >&2 'EXEC:' "$@"; sh "$@"; }
c1642be5 453 ;;
3dc55197
DK
454 --*)
455 echo >&2 "Unknown option: $1"
456 usage
457 exit 1;;
458 *)
459 break;;
460 esac
33a22672 461 shift
3dc55197
DK
462done
463
464if [ -z "$TRUSTEDFILE" ]; then
465 TRUSTEDFILE="/etc/apt/trusted.gpg"
466 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
467 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
46e39c8e 468fi
46e39c8e 469
b3d44315
MV
470command="$1"
471if [ -z "$command" ]; then
472 usage
473 exit 1
474fi
475shift
476
29c59095
DK
477find_gpgv_status_fd() {
478 while [ -n "$1" ]; do
479 if [ "$1" = '--status-fd' ]; then
480 shift
481 echo "$1"
482 break
483 fi
484 shift
485 done
486}
487GPGSTATUSFD="$(find_gpgv_status_fd "$@")"
488
105503b4
DK
489warn() {
490 if [ -z "$GPGHOMEDIR" ]; then
491 echo >&2 'W:' "$@"
492 else
493 echo 'W:' "$@" > "${GPGHOMEDIR}/aptwarnings.log"
494 fi
29c59095
DK
495 if [ -n "$GPGSTATUSFD" ]; then
496 echo >&${GPGSTATUSFD} '[APTKEY:] WARNING' "$@"
497 fi
105503b4
DK
498}
499
4039798d
DK
500cleanup_gpg_home() {
501 if [ -z "$GPGHOMEDIR" ]; then return; fi
105503b4
DK
502 if [ -s "$GPGHOMEDIR/aptwarnings.log" ]; then
503 cat >&2 "$GPGHOMEDIR/aptwarnings.log"
504 fi
4039798d 505 if command_available 'gpgconf'; then
215598df 506 GNUPGHOME="${GPGHOMEDIR}" gpgconf --kill gpg-agent >/dev/null 2>&1 || true
4039798d
DK
507 fi
508 rm -rf "$GPGHOMEDIR"
509}
510
25f27319
DK
511create_gpg_home() {
512 # gpg needs (in different versions more or less) files to function correctly,
513 # so we give it its own homedir and generate some valid content for it later on
514 if [ -n "$TMPDIR" ]; then
515 # tmpdir is a directory and current user has rwx access to it
516 # same tests as in apt-pkg/contrib/fileutl.cc GetTempDir()
517 if [ ! -d "$TMPDIR" ] || [ ! -r "$TMPDIR" ] || [ ! -w "$TMPDIR" ] || [ ! -x "$TMPDIR" ]; then
518 unset TMPDIR
519 fi
520 fi
521 GPGHOMEDIR="$(mktemp -d)"
4039798d 522 CURRENTTRAP="${CURRENTTRAP} cleanup_gpg_home;"
25f27319 523 trap "${CURRENTTRAP}" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
4039798d
DK
524 if [ -z "$GPGHOMEDIR" ]; then
525 echo "ERROR: Could not create temporary gpg home directory in apt-key ($TMPDIR)"
526 exit 28
527 fi
25f27319
DK
528 chmod 700 "$GPGHOMEDIR"
529}
530
531prepare_gpg_home() {
5f17b19f
DK
532 # crude detection if we are called from a maintainerscript where the
533 # package depends on gnupg or not. We accept recommends here as
534 # well as the script hopefully uses apt-key optionally then like e.g.
535 # debian-archive-keyring for (upgrade) cleanup did
08fcf962 536 if [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] && [ -z "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then
2e49f519 537 if ! dpkg-query --show --showformat '${Pre-Depends}${Depends}${Recommends}\n' "$DPKG_MAINTSCRIPT_PACKAGE" 2>/dev/null | grep -q gnupg; then
5f17b19f
DK
538 cat >&2 <<EOF
539Warning: The $DPKG_MAINTSCRIPT_NAME maintainerscript of the package $DPKG_MAINTSCRIPT_PACKAGE
540Warning: seems to use apt-key (provided by apt) without depending on gnupg or gnupg2.
541Warning: This will BREAK in the future and should be fixed by the package maintainer(s).
542Note: Check first if apt-key functionality is needed at all - it probably isn't!
543EOF
544 fi
545 fi
bc8f83a5 546 eval "$(apt-config shell GPG_EXE Apt::Key::gpgcommand)"
e23ee4c2 547 if [ -n "$GPG_EXE" ] && command_available "$GPG_EXE"; then
93d0d08c 548 true
e23ee4c2 549 elif command_available 'gpg'; then
93d0d08c 550 GPG_EXE="gpg"
e23ee4c2 551 elif command_available 'gpg2'; then
93d0d08c 552 GPG_EXE="gpg2"
19fdf93d
DK
553 elif command_available 'gpg1'; then
554 GPG_EXE="gpg1"
93d0d08c 555 else
19fdf93d
DK
556 echo >&2 "Error: gnupg, gnupg2 and gnupg1 do not seem to be installed,"
557 echo >&2 "Error: but apt-key requires gnupg, gnupg2 or gnupg1 for this operation."
9fda3be1 558 echo >&2
93d0d08c 559 exit 255
9fda3be1
DK
560 fi
561
25f27319
DK
562 create_gpg_home
563
05991180
DK
564 # create the trustdb with an (empty) dummy keyring
565 # older gpgs required it, newer gpgs even warn that it isn't needed,
566 # but require it nonetheless for some commands, so we just play safe
567 # here for the foreseeable future and create a dummy one
803491dc 568 touch "${GPGHOMEDIR}/empty.gpg"
fecfbf2e 569 if ! "$GPG_EXE" --ignore-time-conflict --no-options --no-default-keyring \
803491dc 570 --homedir "$GPGHOMEDIR" --quiet --check-trustdb --keyring "${GPGHOMEDIR}/empty.gpg" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
fecfbf2e
DK
571 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
572 false
573 fi
803491dc
DK
574
575 # now tell gpg that it shouldn't try to maintain this trustdb file
fecfbf2e 576 echo "#!/bin/sh
bc8f83a5
DK
577exec '$(escape_shell "${GPG_EXE}")' --ignore-time-conflict --no-options --no-default-keyring \\
578--homedir '$(escape_shell "${GPGHOMEDIR}")' --no-auto-check-trustdb --trust-model always \"\$@\"" > "${GPGHOMEDIR}/gpg.0.sh"
fecfbf2e
DK
579 GPG_SH="${GPGHOMEDIR}/gpg.0.sh"
580 GPG="$GPG_SH"
05991180 581
803491dc 582 # We don't usually need a secret keyring, of course, but
bd7fb5aa
DK
583 # for advanced operations, we might really need a secret keyring after all
584 if [ -n "$FORCED_SECRET_KEYRING" ] && [ -r "$FORCED_SECRET_KEYRING" ]; then
803491dc
DK
585 if ! aptkey_execute "$GPG" -v --batch --import "$FORCED_SECRET_KEYRING" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
586 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
587 false
588 fi
589 else
590 # and then, there are older versions of gpg which panic and implode
591 # if there isn't one available - and writeable for imports
592 # and even if not output is littered with the creation of a secring,
593 # so lets call import once to have it create what it wants in silence
594 echo -n | aptkey_execute "$GPG" --batch --import >/dev/null 2>&1 || true
bd7fb5aa 595 fi
25f27319
DK
596}
597
08fcf962
DK
598warn_on_script_usage() {
599 if [ -n "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then
600 return
601 fi
602 # (Maintainer) scripts should not be using apt-key
603 if [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ]; then
604 echo >&2 "Warning: apt-key should not be used in scripts (called from $DPKG_MAINTSCRIPT_NAME maintainerscript of the package ${DPKG_MAINTSCRIPT_PACKAGE})"
605 elif [ ! -t 1 ]; then
606 echo >&2 "Warning: apt-key output should not be parsed (stdout is not a terminal)"
607 fi
608}
609
25f27319
DK
610if [ "$command" != 'help' ] && [ "$command" != 'verify' ]; then
611 prepare_gpg_home
b3d44315
MV
612fi
613
b3d44315
MV
614case "$command" in
615 add)
08fcf962 616 warn_on_script_usage
5beb682d
DK
617 requires_root
618 setup_merged_keyring
fecfbf2e 619 aptkey_execute "$GPG" --quiet --batch --import "$@"
0dae96a2 620 merge_back_changes
5beb682d 621 aptkey_echo "OK"
b3d44315
MV
622 ;;
623 del|rm|remove)
08fcf962 624 # no script warning here as removing 'add' usage needs 'del' for cleanup
5beb682d
DK
625 requires_root
626 foreach_keyring_do 'remove_key_from_keyring' "$@"
627 aptkey_echo "OK"
b3d44315 628 ;;
4a242c5b 629 update)
08fcf962 630 warn_on_script_usage
5beb682d
DK
631 requires_root
632 setup_merged_keyring
4a242c5b 633 update
0dae96a2 634 merge_back_changes
4a242c5b 635 ;;
848ecfa4 636 net-update)
5beb682d
DK
637 requires_root
638 setup_merged_keyring
848ecfa4 639 net_update
0dae96a2 640 merge_back_changes
848ecfa4 641 ;;
a5f9b45e 642 list|finger*)
08fcf962 643 warn_on_script_usage
0b94a7bc 644 foreach_keyring_do 'run_cmd_on_keyring' --fingerprint "$@"
5beb682d 645 ;;
4f51a496 646 export|exportall)
08fcf962 647 warn_on_script_usage
25f27319 648 merge_all_trusted_keyrings_into_pubring
fecfbf2e 649 aptkey_execute "$GPG_SH" --keyring "${GPGHOMEDIR}/pubring.gpg" --armor --export "$@"
5beb682d 650 ;;
b3d44315 651 adv*)
08fcf962 652 warn_on_script_usage
5beb682d
DK
653 setup_merged_keyring
654 aptkey_echo "Executing: $GPG $*"
fecfbf2e 655 aptkey_execute "$GPG" "$@"
0dae96a2 656 merge_back_changes
5beb682d 657 ;;
c46a36ad 658 verify)
f14cde2c
DK
659 GPGV=''
660 eval $(apt-config shell GPGV Apt::Key::gpgvcommand)
e23ee4c2
DK
661 if [ -n "$GPGV" ] && command_available "$GPGV"; then true;
662 elif command_available 'gpgv'; then GPGV='gpgv';
663 elif command_available 'gpgv2'; then GPGV='gpgv2';
19fdf93d 664 elif command_available 'gpgv1'; then GPGV='gpgv1';
25f27319 665 else
19fdf93d 666 echo >&2 'ERROR: gpgv, gpgv2 or gpgv1 required for verification'
25f27319 667 exit 29
f14cde2c 668 fi
25f27319
DK
669 # for a forced keyid we need gpg --export, so full wrapping required
670 if [ -n "$FORCED_KEYID" ]; then
671 prepare_gpg_home
672 else
673 create_gpg_home
674 fi
675 setup_merged_keyring
676 if [ -n "$FORCED_KEYRING" ]; then
fecfbf2e 677 "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "${FORCED_KEYRING}" --ignore-time-conflict "$@"
c46a36ad 678 else
fecfbf2e 679 "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "${GPGHOMEDIR}/pubring.gpg" --ignore-time-conflict "$@"
c46a36ad
DK
680 fi
681 ;;
b3d44315
MV
682 help)
683 usage
684 ;;
685 *)
686 usage
687 exit 1
688 ;;
689esac